%% Pattern Generation
% Cedric Yue Sik Kin, Andrew Ponec
%
% Script to generate different patterns to be displayed on DMD 

%% Raster Patterns
clear

num_cols = 608;
num_rows = 684;
pixel_size = 20;

status = mkdir('rasterPatterns', sprintf('size%i', pixel_size)); 

res_x = floor(num_cols/pixel_size);
res_y = floor(num_rows/pixel_size);

count = 0;

for row = 0:res_y
    for col = 0:res_x
        pattern = zeros(num_rows, num_cols);
        
        if row == res_y && col == res_x
            
            continue;
            %pattern(row*pixel_size+1:end, ...
            %    col*pixel_size+1:end, :) = 255;
            
        elseif row == res_y && col ~= res_x
            
            continue;
            %pattern(row*pixel_size+1:end, ...
            %    col*pixel_size+1:(col+1)*pixel_size, :) = 255;
            
        elseif col == res_x && row ~= res_y
        
            continue;
            %pattern(row*pixel_size+1:(row+1)*pixel_size, ...
            %    col*pixel_size+1:end, :) = 255;
            
        else
            
            pattern(row*pixel_size+1:(row+1)*pixel_size, ...
                col*pixel_size+1:(col+1)*pixel_size) = 1;
            
        end
        
        imwrite(logical(pattern), sprintf('rasterPatterns/size%i/pattern%i.bmp', ...
            pixel_size, count), 'bmp');
        count = count + 1;
        
    end
end

%% Hadamard Patterns
clear; close all;

num_cols = 608;
num_rows = 684;

res = 16;

factor = floor(num_cols/res);

had = hadamard(res*res);

status = mkdir('hadamardPatterns', sprintf('res%i', res)); 

count = 0;
for row = 1:size(had, 1)
    
    pattern = had(row, :);
    pattern = reshape(pattern, res, res)';
    pattern(pattern == -1) = 0;
    pattern(pattern == 1) = 1;
    
    pattern2 = reshape(repmat(pattern(:)',factor,1),[],size(pattern, 2));
    pattern2 = reshape(repmat(reshape(pattern2',[],1),1,factor)',[],...
        size(pattern2,1))';
    
    
%     pattern2 = cat(3, pattern2, pattern2, pattern2);
    
    pattern3 = padarray(pattern2, [(num_rows-size(pattern2, 1))/2 ...
        (num_cols-size(pattern2, 2))/2]);
    
    imwrite(logical(pattern3), sprintf('hadamardPatterns/res%i/pattern%i.bmp', ...
            res, count), 'bmp');
        
    count = count + 1;

end
